;sound effects list
; params
; 0 priority 			0-127	(b) bit 7 = only in full sfx mode
; 1 prefered channel 	0-2		(b)
; 2 sample ID on AT		0-255	(b)
; 3 note				note note+(octave*12) (b) 
; 4 speed				speed 0-255 (b)
; 5 priority for full SFX
; 6 struct size

read "sfx_names.asm"

;Do ? Do# ? R ? R# ? Mi ? Fa ? Fa# ? Sol ? Sol# ? La ? La# ? Si 
;C	  C#	D	 D#	   E    F	 F#    G     G#     A    A#    B
;3    4     5    6     7    8    9     10    11     0    1     2

chan_A	EQU 0
chan_B	EQU 1
chan_C	EQU 2


note_C	EQU 0
note_Cs	EQU 1
note_D	EQU 2
note_Ds	EQU 3
note_E	EQU 4
note_F	EQU 5
note_Fs	EQU 6
note_G	EQU 7
note_Gs	EQU 8

note_A	EQU 9
note_As	EQU 10
note_B	EQU 11

macro def_sound priorityA,priorityB,channel,sample,note,octave,speed
	let octave_val=octave*12
	db priorityA,channel,sample,note+octave_val,priorityB
	;ds 2,0 ;reserved/padding
mend

macro make_note note,octave
	let note_val=octave*12
	db note_val+note
mend

.sfx_table

;sound def priority1Channel,priority3Channel,Channel,ArkosSampleID,note,octave,speed
def_sound 32,16,chan_C,3,note_A,5,0		;0 - touch sound
def_sound 16,16,chan_B,5,note_F,5,0		;1 - attach module
def_sound 16,16,chan_B,6,note_F,5,0		;2 - release module
def_sound 32,16,chan_C,7,note_A,7,0		;3 - sfx_explodeA
def_sound 16,16,chan_C,8,note_A,0,0		;4 - sfx_explodeB
def_sound 16,16,chan_B,9,note_A,0,0		;5 - sfx_explodeC
def_sound 0,16,chan_B,#13,note_C,5,0		;6 - sfx_bonus
def_sound 0,0,chan_B,#16,note_A,5,0		;7 - sfx menu move
def_sound 48,16,chan_B,2,note_A,0,0		;8 - missiles launch - player
def_sound 16,0,chan_A,1,note_F,3,0		;9 - beam
def_sound 32,32,chan_B,#E,note_A,0,0		;10 - green alien on L1
def_sound 32,32,chan_B,#F,note_A,0,0		;11 - red robot on L1
def_sound 32,0,chan_C,#10,note_A,0,0		;12 - boss 1 shot
def_sound 0,0,chan_A,#1B,note_E,0,0		;13 - player explose
def_sound 0+128,0,chan_A,#11,note_D,5,0		;14 - beam load
def_sound 0+128,32,chan_B,2,note_A,0,0		;15 - enemy missiles launch (same but SFX mode only)
def_sound 0+128,16,chan_A,#A,note_G,6,0		;16 - laser shoot
def_sound 0+128,48,chan_B,#B,note_F,6,0		;17 - laser bounce
def_sound 0+128,16,chan_A,#C,note_E,4,0		;18 - circular
def_sound 0+128,16,chan_A,#D,note_A,3,0		;19 - fire
def_sound 0+128,16,chan_A,#12,note_A,0,0	;20 - base shoot
def_sound 0,0,chan_B,#14,note_Cs,6,0		;21 - 1UP
def_sound 0,0,chan_B,#15,note_Cs,6,0		;22 - START GAME
def_sound 32,0,chan_C,#18,note_D,1,0		;23 - Boss 0 open
def_sound 32,0,chan_C,#19,note_D,3,0		;24 - Boss 0 shoot
def_sound 0+128,32,chan_C,#1A,note_Fs,4,0	;25 - hyperbullet shoot
def_sound 0,0,chan_B,#1C,note_Fs,5,0		;26 - pause
def_sound 0+128,0,chan_B,#1D,note_D,6,0		;27 - points
def_sound 32,0,chan_C,#19,note_D,4,0		;28 - Boss 0 shoot Little
def_sound 0,16,chan_B,#17,note_Cs,6,0		;29 - Easter-Egg Add credit
def_sound 0+128,16,chan_B,4,note_F,2,0		;30 - Boss Level 2 Tubes
def_sound 0+128,16,chan_B,#1E,note_B,1,0	;31 - Boss Level 5 Deadly Parts
def_sound 0+128,16,chan_C,#1F,note_As,6,0	;32 - Monster Laser (Level 5 and 7)
def_sound 32,0,chan_C,#20,note_B,3,0		;33 - Boss Level 4 Laser
def_sound 0+128,16,chan_B,#21,note_A,0,0	;34 - Falling Garbages (Level 7)
def_sound 32,0,chan_C,#22,note_A,0,0		;35 - Boss 7 shot
def_sound 0+128,16,chan_B,#23,note_F,5,0	;36 - Garbage Bug (Level 7)
def_sound 16,0,chan_B,#24,note_E,1,0		;37 - Boss Level 4 crush
def_sound 0+128,16,chan_C,#25,note_A,4,0	;38 - Touch Sound 2 (Boss Level 5 Deadly Parts)
def_sound 0+128,0,chan_B,#26,note_B,1,0		;39 - Opening Trashcan (Level 7)
def_sound 0+128,16,chan_C,#19,note_C,2,0	;40 - Medusa Level 2

def_sound 32,16,chan_C,3,note_A,5,0		;41 - touch sound boss

